Index: typo3/sysext/lang/locallang_csh_corebe.xml
===================================================================
--- typo3/sysext/lang/locallang_csh_corebe.xml	(revision 8762)
+++ typo3/sysext/lang/locallang_csh_corebe.xml	(working copy)
@@ -141,7 +141,7 @@
 			<label index="_list_searchbox.seeAlso">xMOD_csh_corebe:list_module</label>
 			<label index="_list_searchbox.image">EXT:lang/cshimages/core_15.png,</label>
 			<label index="list_options.alttitle">List module options</label>
-			<label index="list_options.description">Enable the &quot;Extended view&quot; mode to see additional control buttons for each record in the listing. Enable the &quot;Clipboard&quot; to see the clipboard and its content.</label>
+			<label index="list_options.description">Enable additional options, e.g. the &quot;Extended view&quot; mode to see additional control buttons for each record in the listing or the &quot;Clipboard&quot; to see the clipboard and its content.</label>
 			<label index="_list_options.seeAlso">xMOD_csh_corebe:list_module,
 xMOD_csh_corebe:list_clipboard,
 xMOD_csh_corebe:filelist_options</label>
Index: typo3/sysext/list/mod1/db_list.php
===================================================================
--- typo3/sysext/list/mod1/db_list.php	(revision 8762)
+++ typo3/sysext/list/mod1/db_list.php	(working copy)
@@ -369,21 +369,39 @@
 			$this->body.='
 
 					<!--
-						Listing options for clipboard and thumbnails
+						Listing options for extended view, clipboard and localization view
 					-->
 					<div id="typo3-listOptions">
 						<form action="" method="post">';
 
-			$this->body.=t3lib_BEfunc::getFuncCheck($this->id,'SET[bigControlPanel]',$this->MOD_SETTINGS['bigControlPanel'],'db_list.php',($this->table?'&table='.$this->table:''),'id="checkLargeControl"').' <label for="checkLargeControl">'.$LANG->getLL('largeControl',1).'</label><br />';
-			if ($dblist->showClipboard)	{
-				$this->body.=t3lib_BEfunc::getFuncCheck($this->id,'SET[clipBoard]',$this->MOD_SETTINGS['clipBoard'],'db_list.php',($this->table?'&table='.$this->table:''),'id="checkShowClipBoard"').' <label for="checkShowClipBoard">'.$LANG->getLL('showClipBoard',1).'</label><br />';
+			if ($GLOBALS['BE_USER']->getTSConfigVal('mod.SHARED.enableDisplayBigControlPanel')) {
+					// Add "display bigControlPanel" checkbox:
+				$this->body.=t3lib_BEfunc::getFuncCheck($this->id,'SET[bigControlPanel]',$this->MOD_SETTINGS['bigControlPanel'],'db_list.php',($this->table?'&table='.$this->table:''),'id="checkLargeControl"').' <label for="checkLargeControl">'.$LANG->getLL('largeControl',1).'</label><br />';
 			}
-			$this->body.=t3lib_BEfunc::getFuncCheck($this->id,'SET[localization]',$this->MOD_SETTINGS['localization'],'db_list.php',($this->table?'&table='.$this->table:''),'id="checkLocalization"').' <label for="checkLocalization">'.$LANG->getLL('localization',1).'</label><br />';
+
+			if ($GLOBALS['BE_USER']->getTSConfigVal('mod.SHARED.enableClipBoard')) {
+					// Add "clipboard" button:
+				if ($dblist->showClipboard)	{
+					$this->body.=t3lib_BEfunc::getFuncCheck($this->id,'SET[clipBoard]',$this->MOD_SETTINGS['clipBoard'],'db_list.php',($this->table?'&table='.$this->table:''),'id="checkShowClipBoard"').' <label for="checkShowClipBoard">'.$LANG->getLL('showClipBoard',1).'</label><br />';
+				}
+			}
+
+			if ($GLOBALS['BE_USER']->getTSConfigVal('mod.web_list.enableLocalizationView')) {
+					// Add "localization view" checkbox:
+				$this->body.=t3lib_BEfunc::getFuncCheck($this->id,'SET[localization]',$this->MOD_SETTINGS['localization'],'db_list.php',($this->table?'&table='.$this->table:''),'id="checkLocalization"').' <label for="checkLocalization">'.$LANG->getLL('localization',1).'</label><br />';
+			}
+
 			$this->body.='
 						</form>
 					</div>';
-			$this->body.= t3lib_BEfunc::cshItem('xMOD_csh_corebe', 'list_options', $GLOBALS['BACK_PATH']);
 
+				// Add CSH, if at least one option is available:
+			if ($GLOBALS['BE_USER']->getTSConfigVal('options.enableDisplayBigControlPanel')
+				|| $GLOBALS['BE_USER']->getTSConfigVal('options.enableClipBoard')
+				|| $GLOBALS['BE_USER']->getTSConfigVal('options.enableLocalizationView')) {
+					$this->body .= t3lib_BEfunc::cshItem('xMOD_csh_corebe', 'list_options', $GLOBALS['BACK_PATH']);
+			}
+
 				// Printing clipboard if enabled:
 			if ($this->MOD_SETTINGS['clipBoard'] && $dblist->showClipboard)	{
 				$this->body.= $dblist->clipObj->printClipboard();
Index: t3lib/config_default.php
===================================================================
--- t3lib/config_default.php	(revision 8762)
+++ t3lib/config_default.php	(working copy)
@@ -226,7 +226,11 @@
 		'forceCharset' => '',					// String: Normally the charset of the backend users language selection is used. If you set this value to a charset found in t3lib/csconvtbl/ (or "utf-8") the backend (and database) will ALWAYS use this charset. Always use a lowercase value.
 		'installToolPassword' => '',			// String: This is the md5-hashed password for the Install Tool. Set this to '' and access will be totally denied. PLEASE consider to externally password protect the typo3/install/ folder, eg. with a .htaccess file.
 		'defaultUserTSconfig' => 'options.enableShortcuts=1
-			options.enableShowPalettes=1',	// String (exclude). Enter lines of default backend user/group TSconfig.
+			options.enableShowPalettes=1
+			mod.SHARED.enableDisplayBigControlPanel=1
+			mod.SHARED.enableClipBoard=1
+			mod.web_list.enableLocalizationView=1
+			mod.file_filelist.enableDisplayThumbnails=1',	// String (exclude). Enter lines of default backend user/group TSconfig.
 		'defaultPageTSconfig' => '',			// String (exclude).Enter lines of default Page TSconfig.
 		'defaultPermissions' => array (			// Default permissions set for new pages in t3lib/tce_main.php. Keys are 'show,edit,delete,new,editcontent'. Enter as comma-list
 //			'user' => '',						// default in tce_main is 'show,edit,delete,new,editcontent'. If this is set (uncomment), this value is used instead.
Index: typo3/sysext/filelist/mod1/file_list.php
===================================================================
--- typo3/sysext/filelist/mod1/file_list.php	(revision 8762)
+++ typo3/sysext/filelist/mod1/file_list.php	(working copy)
@@ -331,19 +331,25 @@
 				$pageContent.='
 
 					<!--
-						Listing options for clipboard and thumbnails
+						Listing options for extended view, clipboard and thumbnails
 					-->
 					<div id="typo3-listOptions">
 				';
 
-			   		// Add "display bigControlPanel" checkbox:
-				$pageContent.=t3lib_BEfunc::getFuncCheck($this->id, 'SET[bigControlPanel]', $this->MOD_SETTINGS['bigControlPanel'], 'file_list.php', '', 'id="bigControlPanel"') . '<label for="bigControlPanel"> ' .$LANG->getLL('bigControlPanel', 1) . '</label><br />';
+				if ($GLOBALS['BE_USER']->getTSConfigVal('mod.SHARED.enableDisplayBigControlPanel')) {
+				   		// Add "display bigControlPanel" checkbox:
+					$pageContent.=t3lib_BEfunc::getFuncCheck($this->id, 'SET[bigControlPanel]', $this->MOD_SETTINGS['bigControlPanel'], 'file_list.php', '', 'id="bigControlPanel"') . '<label for="bigControlPanel"> ' .$LANG->getLL('bigControlPanel', 1) . '</label><br />';
+				}
 
-					// Add "display thumbnails" checkbox:
-				$pageContent.=t3lib_BEfunc::getFuncCheck($this->id,'SET[displayThumbs]',$this->MOD_SETTINGS['displayThumbs'],'file_list.php','','id="checkDisplayThumbs"').' <label for="checkDisplayThumbs">'.$LANG->getLL('displayThumbs',1).'</label><br />';
+				if ($GLOBALS['BE_USER']->getTSConfigVal('mod.file_filelist.enableDisplayThumbnails')) {
+						// Add "display thumbnails" checkbox:
+					$pageContent.=t3lib_BEfunc::getFuncCheck($this->id,'SET[displayThumbs]',$this->MOD_SETTINGS['displayThumbs'],'file_list.php','','id="checkDisplayThumbs"').' <label for="checkDisplayThumbs">'.$LANG->getLL('displayThumbs',1).'</label><br />';
+				}
 
-					// Add clipboard button
-				$pageContent.=t3lib_BEfunc::getFuncCheck($this->id,'SET[clipBoard]',$this->MOD_SETTINGS['clipBoard'],'file_list.php','','id="checkClipBoard"').' <label for="checkClipBoard">'.$LANG->getLL('clipBoard',1).'</label>';
+				if ($GLOBALS['BE_USER']->getTSConfigVal('mod.SHARED.enableClipBoard')) {
+						// Add "clipboard" button:
+					$pageContent.=t3lib_BEfunc::getFuncCheck($this->id,'SET[clipBoard]',$this->MOD_SETTINGS['clipBoard'],'file_list.php','','id="checkClipBoard"').' <label for="checkClipBoard">'.$LANG->getLL('clipBoard',1).'</label>';
+				}
 
 				$pageContent.='
 					</div>